// PerfomanceCounter

#ifndef _PERFOMANCE_COUNTER_H_
#define _PERFOMANCE_COUNTER_H_

#include "afx.h"
#include "windows.h"

#include <string>
#include <vector>

//------------------------------------------------------------------------------
// PerfomanceData
//------------------------------------------------------------------------------

struct PerfomanceData
{
	PerfomanceData() // : bStart(FALSE), bEnd(FALSE)
	{
		start.QuadPart = 0;
		end.QuadPart = 0;
	}

	//PerfomanceData ( BOOL b ) : bStart(TRUE), bEnd(TRUE)
	//{
	//	ASSERT ( b );
	//	start.QuadPart = 0;
	//	end.QuadPart = 0;
	//}

	double getValue() const;
	std::string getText() const;
	
	PerfomanceData & operator += ( const PerfomanceData & rhs )
	{
		//ASSERT ( bStart && bEnd & rhs.bStart && rhs.bEnd );
		end.QuadPart = ( end.QuadPart - start.QuadPart )
			+ ( rhs.end.QuadPart - rhs.start.QuadPart );
		start.QuadPart = 0;
		return *this;
	}

	LARGE_INTEGER start;
	LARGE_INTEGER end;
	//BOOL bStart;
	//BOOL bEnd;
};

const PerfomanceData operator + ( const PerfomanceData & lhs, const PerfomanceData & rhs );

//------------------------------------------------------------------------------
// PerfomanceCounter
//------------------------------------------------------------------------------

class PerfomanceCounter
{
public:
	PerfomanceCounter()
		: bStart(FALSE), bEnd(FALSE)
	{}

	void start();
	void end();
	PerfomanceData getData() const
	{
		if ( bStart && bEnd )
			return data;
		else
			return PerfomanceData(); // perfomance data not collected
	}

private:
	PerfomanceData data;
	BOOL bStart;
	BOOL bEnd;
};

//------------------------------------------------------------------------------
// PerfomanceDataList
//------------------------------------------------------------------------------

struct PerfomanceDataList
{
	PerfomanceDataList()
		: total_length(0)
	{}

	void print() const;
	PerfomanceData getSum() const;

	std::vector<PerfomanceData> pd_list;
	std::vector<std::string> string_list;
	unsigned total_length;
};

//------------------------------------------------------------------------------

#endif // __PERFOMANCE_COUNTER_H__