// allocator_extern.h

#pragma once

#ifndef _ALLOCATOR_EXTERN_H_
#define _ALLOCATOR_EXTERN_H_

#include "allocator_id.h"
//#include "allocator2.h"



#pragma warning ( disable : 4506 )

//-----------------------------------------------------------------------------
// PageAllocator
//-----------------------------------------------------------------------------

template < typename PageChunkAllocator >
class PageAllocator;

//------------------------------------------------------------------------------


//-----------------------------------------------------------------------------
// WindowsPageChunkAllocator
//-----------------------------------------------------------------------------

class WindowsPageChunkAllocator
{
public:
	static const unsigned PageSize = 4096;
};

//------------------------------------------------------------------------------
// OwnPageAllocator
//------------------------------------------------------------------------------


typedef PageAllocator<WindowsPageChunkAllocator> OwnPageAllocator;


//-----------------------------------------------------------------------------
// PageAllocator
//-----------------------------------------------------------------------------

template < typename PageChunkAllocator >
class PageAllocator
{
public:
	static void * allocate();
	static void deallocate ( void * address );

	static const int page_size = PageChunkAllocator::PageSize; // page size in bytes
};

//-----------------------------------------------------------------------------
// FixedSmallObjAllocator
//-----------------------------------------------------------------------------

template
<
	unsigned Size,
	unsigned Index,
	//typename T,
	//int node_align,
	typename PageAllocator
	//typename DebugTraits = DebugMagicTraits<T,node_align>
>
class FixedSmallObjAllocator
{
public:
	static inline void * allocate();
	static inline void deallocate ( void * address );
};

//-----------------------------------------------------------------------------


#endif // _ALLOCATOR_EXTERN_H_