// project.cpp

#include "stdafx.h"
#include <vector>
#include <set>
#include "ICsProject.h"
#include "ICsFile.h"
#include "IAssembly.h"
#include "ICsParserInterface.h"
#include "PerfomanceStatistics.h"

#include "CommandLineOptions.h"
#include "FileManager.h"
#include "PerfomanceCounter.h"
#include "RefactoringManager.h"

//--------------------------------------------------------------

void process_project
(
	std::vector<ICsFile*> & files,
	std::vector<IAssembly*> & assemblies,
	std::set<std::string> & macros,
	PerfomanceStatistics & perfomanceStatistics
)
{
	ICsProject * project = ICsProject::create();

	project->attachFiles ( (int)files.size(), & files[0] );
	project->attachAssemblies ( (int)assemblies.size(), & assemblies[0] );
	{
		std::set<std::string>::iterator it;
		for ( it = macros.begin(); it != macros.end(); ++it )
		{
			project->addMacro ( it->c_str() );
		}
	}

	//project->parse();
	//perfomanceStatistics += project->getPerfomanceStatistics();

	RefactoringManager rm;
	rm.project = project;

	rm.test();

	delete project;
}

//--------------------------------------------------------------
